---
title: Images
slug: MDN/Editor/Images
tags:
  - Attaching
  - Documentation
  - Guide
  - Images
  - MDN
  - MDN Meta
  - Optimization
  - attachment
  - editor
---
<div>{{MDNSidebar}}</div>

<p><span class="seoSummary">It's frequently useful to include images in articles. Images may be screenshots, examples of what a rendering should look like, or SVG diagrams of program flow, for example. This article describes how to use images in MDN content.</span></p>

<div class="note">
<p><strong>Note</strong>: SVG uploads are disabled for most users due to a security issue. If you need to upload an SVG file, please open a bug and attach the image you'd like to upload.  You can also convert it to a PNG file, which are still allowed.</p>
</div>

<div class="note"><strong>Note: </strong>When uploading an image, please be sure to use an image optimization tool to make the file as small to download as possible. This improves page load time and helps MDN's performance overall. You may use your preferred tool, if you have one. Otherwise, we suggest <a href="https://tinypng.com/">TinyPNG</a>, a handy Web tool.</div>

<h2 id="Workflow_for_attaching_images">Workflow for attaching images</h2>

<p>The way the attachment upload functionality works results in the page being refreshed after each upload. If you had any unsaved edits made to the page at this point, they might be lost. It is therefore a good idea to save your edits first before uploading images.</p>

<p>A good workflow is as follows:</p>

<ol>
 <li>Make edits. Mark places where an image needs inserting with a placeholder, e.g. [EXAMPLE OUTPUT IMAGE HERE].</li>
 <li>Save your edits.</li>
 <li>Attach your images.</li>
 <li>Insert the images in place of the placeholders.</li>
 <li>Save your work again just to be sure.</li>
</ol>

<h2 id="Attaching_an_image_to_an_article">Attaching an image to an article</h2>

<p id="Adding_images_to_an_article">Once you've attached an image to the page (see <a href="/en-US/docs/MDN/Contribute/Editor/Basics/Attachments">Attachments</a>), you can use it in your article. You can also link to images elsewhere on MDN. To insert an image, click  the <strong>Image</strong> button in the toolbar, which looks like this: <img alt="Toolbar icon for inserting image" src="https://mdn.mozillademos.org/files/12475/image_icon.png" style="height: 15px; width: 18px;"></p>

<p>The <strong>Image Properties</strong> dialog box appears, which looks like this:</p>

<p><img alt="Image properties dialog, with no contents; from CKEditor 4.5.4; border shown." src="https://mdn.mozillademos.org/files/12479/image%20properties%20empty.png" style="border-style: solid; border-width: 1px; height: 604px; width: 487px;"></p>

<p>There are three tabs; the first (and the one you'll use most) is the <strong>Image Info</strong> tab. The other two are the <strong>Link</strong> and <strong>Advanced</strong> tabs.</p>

<h2 id="Image_Info">Image Info</h2>

<p>There are many options here:</p>

<dl>
 <dt>Attachments</dt>
 <dd>This popup menu shows a list of the page attachments. Only items you've uploaded during the current editing session, or that are already used elsewhere on the page, are listed.</dd>
 <dt>URL</dt>
 <dd>If you wish to use an image that's not in the attachments list (for example, one attached to a different article on MDN, or uploaded during a previous editing session), you can enter its URL in this field.</dd>
 <dt>Alternative text</dt>
 <dd>The alternative text to be displayed if the image is not displayed. This text is also used by screen readers, so please put an appropriate note here for the sake of accessibility.</dd>
 <dt>Width / Height</dt>
 <dd>You may adjust the width and height of the image as displayed in the article here. By default, these are locked to remain in proportion to one another, but you may toggle that by clicking on the lock icon.</dd>
 <dt>Border</dt>
 <dd>You may optionally specify the width of a black border to draw around your image. <strong>Please</strong> only use the value 0 (or leave blank) or 1 here. Only use a border if your image has a pale background and needs to stand out from the article's background.</dd>
 <dt>HSpace / VSpace</dt>
 <dd>These let you specify how much whitespace to surround the image with horizontally and vertically, respectively. You usually only need to use these if you use the alignment option below.</dd>
 <dt>Alignment</dt>
 <dd>By default, images are displayed alone as their own block. However, you may choose here to float the image to the left or to the right, allowing text to wrap around it. We don't do this often; it's used only in very special cases where the image is small (or very narrow and tall) and there's enough text to put next to it to fill the vertical space. This is a bit of a judgement call. If you use this option, you will probably want to set HSpace and VSpace values to prevent the text from being too close to the image. A value of 6 or 8 for each usually works well.</dd>
</dl>

<p>The preview box gives an example of what the image will look like given your current settings.</p>

<h2 id="Link">Link</h2>

<p>The <strong>Link</strong> tab for images lets you set a URL to go to when the image is clicked. This is most commonly used to link to a larger version of the image itself (by providing the same URL as in the <strong>Image Info</strong> tab). The <strong>Link</strong> tab looks like this:</p>

<p><img alt="Image properties dialog, Link tab; from CKEditor 4.5.4" src="https://mdn.mozillademos.org/files/12483/image%20properties%20link.png" style="border-style: solid; border-width: 1px; height: 527px; width: 484px;"></p>

<dl>
 <dt>URL</dt>
 <dd>Address of a location that the browser navigates to when the user clicks the image.</dd>
 <dt>Target</dt>
 <dd>The browsing context in which to open the specified URL; values correspond to the {{htmlattrxref("target", "a")}} attribute of the {{HTMLElement("a")}}. <strong>Please do not use this field</strong> on MDN. We prefer that all links to open in the same tab.</dd>
</dl>

<h2 id="Supported_image_types">Supported image types</h2>

<p>You may upload GIF, JPEG, and PNG images, as well as SVG diagrams. The preferred image types on MDN are:</p>

<ul>
 <li>PNG for screenshots</li>
 <li>SVG for diagrams, because they can be translated into other languages more easily than other image types</li>
</ul>

<div class="note">
<p><strong>Note:</strong> SVG uploads are disabled because SVG can include JavaScript code, which would introduce potential security issues. If you need to upload an SVG file, please open a bug and attach the image you'd like to upload.  You can also convert it to a PNG file, which you can then upload on your own.</p>
</div>

<p>Photoshop files may also be uploaded. <strong>However</strong>, they may not be used as images inline in content. They are only available for download.</p>

<h2 id="Removing_and_changing_images">Removing and changing images</h2>

<p>To remove an image from the article, you can select it or place the cursor after it, and press the Delete key.</p>

<p>You can also revise the image properties for an image by double-clicking it, or right-clicking on it and choosing <strong>Image Properties</strong> on the context menu that appears. This presents the same dialog as above.</p>

<p>Only MDN administrators can delete attachments. In general, we leave old versions of images in place, because they may be referenced by old revisions of documents. If you find inappropriate or proprietary images on MDN, please contact an <a href="/en-US/docs/MDN/Community/Roles/Admins">MDN admin</a> to remove the attachment, or <a href="https://bugzilla.mozilla.org/enter_bug.cgi?product=Developer+Documentation">file a bug</a> to have it removed.</p>

<h2 id="Image_optimization_tools">Image optimization tools</h2>

<p>Here are a few tools that you may consider using to optimize images:</p>

<ul>
 <li>TinyPNG (<a href="https://tinypng.com">Web</a>)</li>
 <li>ImageOptim (<a href="https://imageoptim.com/online">Web</a>, <a href="https://imageoptim.com/mac">macOS</a>)</li>
 <li>Trimage (<a href="https://trimage.org/">Linux</a>)</li>
</ul>

<p>{{EditorGuideQuicklinks}}</p>
